<template>
	<div class="ext-codexexample-app">
		<cdx-tabs v-model:active="currentTab">
			<cdx-tab
				v-for="tab in tabs"
				:key="tab.name"
				class="ext-codexexample-app__tab"
				:name="tab.name"
				:label="tab.label"
			>
				<component :is="tab.component"></component>
			</cdx-tab>
		</cdx-tabs>
	</div>
</template>

<script>
const { ref } = require( 'vue' );
// Codex is available from ResourceLoader at runtime and is available without needing a build step.
const { CdxTabs, CdxTab } = require( '../../codex.js' );
const ButtonDemo = require( './ButtonDemo.vue' );
const MessageDemo = require( './MessageDemo.vue' );
const LookupDemo = require( './LookupDemo.vue' );
const DialogDemo = require( './DialogDemo.vue' );

/**
 * Codex Vue component demos.
 *
 * This app contains a tabbed layout with various Codex Vue component demos. This component is
 * written using Vue's Composition API (see https://vuejs.org/api/composition-api-setup.html).
 */
// @vue/component
module.exports = {
	name: 'App',
	components: {
		CdxTabs,
		CdxTab
	},
	setup() {
		const currentTab = ref( 'button' );
		const tabs = [
			{
				name: 'button',
				label: mw.msg( 'codexexample-app-tab-label-button' ),
				component: ButtonDemo
			},
			{
				name: 'message',
				label: mw.msg( 'codexexample-app-tab-label-message' ),
				component: MessageDemo
			},
			{
				name: 'lookup',
				label: mw.msg( 'codexexample-app-tab-label-lookup' ),
				component: LookupDemo
			},
			{
				name: 'dialog',
				label: mw.msg( 'codexexample-app-tab-label-dialog' ),
				component: DialogDemo
			}
		];

		return {
			currentTab,
			tabs
		};
	}
};
</script>

<style lang="less">
// To access Codex design tokens and mixins inside Vue files, import MediaWiki skin variables.
@import 'mediawiki.skin.variables.less';

.ext-codexexample-app {
	&__tab {
		padding: @spacing-100;
	}
}
</style>
